
class periph_init
{
 public:
 void gpio()
 {
  PA_ODR = 0;
  PA_CR1 = 0xff-(1<<4);
  PA_DDR = 0;

  PB_CR1 = 0xff-(1<<2|1<<1);
  PB_ODR = 0;
  PB_DDR = 0xff-(1<<1);

  PC_CR1 = 1<<6;
  PC_ODR = 0;
  PC_DDR = 0xff-(1<<6); //pb input

  PD_CR1 = 1<<7|1<<6; 
  PD_ODR = 0;
  PD_DDR = 0xff-(1<<7|1<<1|1);
 }
 void cpu()
 {
  CPU_CFG_GCR_AL = 1;  
 }
 void clk()
 {
  CLK_PCKENR = 7; //tim4,tim3,tim2
 }
 void t2()
 {
  TIM2_PSCR          = 2; // /4
  TIM2_CR1_ARPE      = 1;
  TIM2_CR1_CMS       = 1;
  
  TIM2_CCMR2_COMPARE = pwm1|1<<3;  //blocking rsh signal  
  TIM2_CCMR1_COMPARE = pwm2|1<<3;  //driving npn
  TIM2_CCER1         = 1<<4|1;     //CC2E,CC1E
  TIM2_OISR          = 1;
  TIM2_BKR_BKP       = 1;
  TIM2_BKR_BKE       = 1;  
  TIM2_BKR_OSSI      = 1;
  TIM2_EGR_UG        = 1; 
  TIM2_BKR          |= 3;
  TIM2_CR1_CEN      |= 1;
 }
 void t3()  
 {
  TIM3_PSCR               = 2; // /4 
  TIM3_CCMR1_CAPTURE_CC1S = 1; //input_1 to ccnl_1
  TIM3_CCMR1_CAPTURE_IC1F = 3; //sampling=master, N=8;
  TIM3_CCER1_CC1P         = 1; //active low
  TIM3_CCER1_CC1E         = 1;
  TIM3_IER_CC1IE          = 1;  
  TIM3_CR1                = 1;
 }
 void t4()   //100Hz
 {
   TIM4_ARR   = (u32)2E6/100/256-1;
   TIM4_PSCR  = 8;
   TIM4_IER   = 1;
   TIM4_CR1   = 1;
 }

 void iwdg()
 {
  #define IWDG_KEY_REFRESH         0xAA 
  #define IWDG_KEY_ENABLE          0xCC  
  #define IWDG_WriteAccess_Enable  0x55
  #define IWDG_WriteAccess_Disable 0x00 
  
  #define IWDG_Prescaler_4    0x00
  #define IWDG_Prescaler_8    0x01
  #define IWDG_Prescaler_16   0x02
  #define IWDG_Prescaler_32   0x03
  #define IWDG_Prescaler_64   0x04
  #define IWDG_Prescaler_128  0x05
  #define IWDG_Prescaler_256  0x06
  
  IWDG_KR  = IWDG_KEY_ENABLE;
  IWDG_KR  = IWDG_WriteAccess_Enable;
  IWDG_PR  = IWDG_Prescaler_256;
  IWDG_RLR = 0xff;
  IWDG_KR  = IWDG_KEY_REFRESH;
 }
}cfg;

